import { NodeClass, QualifiedName } from "node-opcua-data-model";
import { NodeId } from "node-opcua-nodeid";
import { IBasicSessionReadAsyncSimple } from "node-opcua-pseudo-session";
import { DataTypeDefinition } from "node-opcua-types";
import { Options } from "../options";
export interface Import {
    name: string;
    module: string;
    namespace: number;
    name2?: string;
}
interface CacheInterfaceNamespace {
    namespaceUri: string;
    sourceFolder: string;
    module: string;
    symbols: {
        [key: string]: number;
    };
}
interface CacheInterface {
    namespace: CacheInterfaceNamespace[];
    requestedSymbols: RequestedSymbol;
}
export interface RequestedSubSymbol {
    subSymbols: {
        [key: string]: number;
    };
}
interface RequestedSymbol {
    namespace: {
        symbols: {
            [key: string]: RequestedSubSymbol;
        };
    }[];
}
export declare function makeName2(name: string): string;
export declare class Cache implements CacheInterface {
    namespace: CacheInterfaceNamespace[];
    requestedSymbols: RequestedSymbol;
    requestedBasicTypes: {
        [key: string]: number;
    };
    imports: {
        [key: string]: {
            [key: string]: number;
        };
    };
    constructor();
    resetRequire(): void;
    referenceBasicType(basicType: string): string;
    _reference(namespaceIndex: number, typeName: string, mainTypeName?: string): void;
    ensureImported(i: Import): void;
}
export declare function referenceExtensionObject(session: IBasicSessionReadAsyncSimple, extensionObjectDataType: NodeId): Promise<Import>;
export declare function referenceEnumeration(session: IBasicSessionReadAsyncSimple, enumerationDataType: NodeId): Promise<Import>;
export declare class Cache2 extends Cache {
    namespaceArray: string[];
}
export declare function constructCache(session: IBasicSessionReadAsyncSimple, options: Options): Promise<Cache2>;
export declare function makeTypeNameNew(nodeClass: NodeClass, definition: DataTypeDefinition | null, browseName: QualifiedName, suffix?: string): Import;
export {};
