"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.f1 = exports.f2 = void 0;
exports.toComment = toComment;
exports.toJavascritPropertyName = toJavascritPropertyName;
exports.quotifyIfNecessary = quotifyIfNecessary;
const node_opcua_utils_1 = require("node-opcua-utils");
const wordwrap_1 = __importDefault(require("wordwrap"));
const wrapText = (0, wordwrap_1.default)(0, 50);
function toComment(prefix, description) {
    const d = wrapText(description);
    return d
        .split("\n")
        .map((x) => prefix + x)
        .join("\n");
}
// to avoid clashes
function toJavascritPropertyName(childName, { ignoreConflictingName }) {
    childName = (0, node_opcua_utils_1.lowerFirstLetter)(childName);
    if (ignoreConflictingName) {
        if (childName === "namespaceUri") {
            childName = "$namespaceUri";
        }
        if (childName === "rolePermissions") {
            childName = "$rolePermissions";
        }
        if (childName === "displayName") {
            childName = "$displayName";
        }
        if (childName === "eventNotifier") {
            childName = "$eventNotifier";
        }
        if (childName === "description") {
            childName = "$description";
        }
        if (childName === "decode") {
            childName = "$decode";
        }
        if (childName === "encode") {
            childName = "$encode";
        }
    }
    return childName.replace(/</g, "$").replace(/>/g, "$").replace(/ |\./g, "_").replace(/#/g, "_");
}
function quotifyIfNecessary(s) {
    if (s.match(/(^[^a-zA-Z])|([^a-zA-Z_0-9])/)) {
        return `"${s}"`;
    }
    if (s === "nodeClass") {
        return `["$nodeClass"]`;
    }
    return s;
}
const f2 = (str) => str.padEnd(60, "-");
exports.f2 = f2;
const f1 = (str) => str.padEnd(60, " ");
exports.f1 = f1;
//# sourceMappingURL=utils2.js.map